Meta.SetName "Hacking Forensics II"
Meta.SetRoomName "V.P.1"
Meta.SetLines(80)
Meta.SetMemory(5)
Meta.SetObjectiveText [[
An infection has spread through the Marvellous Inc. servers. It started on multiple servers, from there went to more servers.
- Each green console has a single number, the console that was infected after it. The last consoles to be infected has the number -1. The number of the console is the row it is on.
- Write the numbers of the green consoles that was infected to the blue console. Highest first.
]]
Meta.SetExtraInfo {
"You have only 5 register position.",
"Notice that you can only read the number from the console once."
}

Floor.SetAll(",,,,,,,,,,,,,,,,,,,,,"..
             ",wwwwwwwwwwwwwwwwwww,"..
             ",w,,,,,,,,,,,,,,,,,w,"..
             ",w,wwwwwwwwwwwwwww,w,"..
             ",w,w,,,,,,,,,,,,,w,w,"..
             ",w,w,wwwwwwwwwww,w,w,"..
             ",w,w,w,,,,,,,,,w,w,w,"..
             ",w,w,w,wwwwwww,w,w,w,"..
             ",w,w,w,w,,,,,w,w,w,w,"..
             ",w,w,w,w,www,w,w,w,w,"..
             ",w,w,w,w,w,w,w,w,w,w,"..
             ",w,w,w,w,www,w,w,w,w,"..
             ",w,w,w,w,,,,,w,w,w,w,"..
             ",w,w,w,wwwwwww,w,w,w,"..
             ",w,w,w,,,,,,,,,w,w,w,"..
             ",w,w,wwwwwwwwwww,w,w,"..
             ",w,w,,,,,,,,,,,,,w,w,"..
             ",w,wwwwwwwwwwwwwww,w,"..
             ",w,,,,,,,,,,,,,,,,,w,"..
             ",wwwwwwwwwwwwwwwwwww,"..
             ",,,,,,,,,,,,,,,,,,,,,")

Floor.Register("white_floor", 'w')
Floor.Register("black_floor",    ',')

-- The following are keywords for constants:
-- ROWS: number of rows
-- COLS: number of columns

-- Declaration of the Floor map is not required. You can use Floor:PlaceAt to cover all tiles and
-- not declare the Floor object. Note, however, that if the map floor is not completely filled, the
-- parser will stop and output an error.

-- For both Object and Floor maps, unregistered characters are set to nothing.

-- The Object Layer (string).
Objects.SetAll("---------------------"..
               "---------------------"..
               "---------------------"..
               "---------------------"..
               "---------------------"..
               "---------------------"..
               "---------------------"..
               "---------------------"..
               "---------------------"..
               "---------------------"..
               "---------------------"..
               "---------------------"..
               "---------------------"..
               "---------------------"..
               "---------------------"..
               "---------------------"..
               "---------------------"..
               "---------------------"..
               "---------------------"..
               "---------------------"..
               "---------------------")

local e = Console {
  color = "blue",
  type  = "output",
  dir   = "west",
}

Objects.Register(e, 'a')
Objects.PlaceAt(e, 11, 11)

local function rnd(l, r) return math.random(l, r) end

local perm = {}
for i = 1, 21 do perm[i] = i end
for i = 1, 20 do
    local j = rnd(i, 21)
    perm[i], perm[j] = perm[j], perm[i]
end
local val = {}
val[perm[21]] = -1
for i = 1, 20 do
    val[perm[i]] = perm[i + 1]
end
val[perm[10]] = -1
local ans = { }
if perm[1] > perm[11] then
    ans[1] = perm[1]
    ans[2] = perm[11]
else
    ans[1] = perm[11]
    ans[2] = perm[1]
end

local alphabet = 'cdefghijklmnopqrstuvwxyz'
for i = 1, 21 do
    local vec = { val[i] }
    local c = Console {
        color = "green",
        type  = "input",
        dir   = "east",
        data  = vec,
        preview_numbers = 0
    }
    Objects.Register(c, alphabet:sub(i,i))
    Objects.PlaceAt(c, i, 1)
end


-- And place the new tile using Floor:Register. Note that Floor gives preference to custom tiles.
-- So if you name your new tile "white_floor", all "white_floor" tiles placed in this puzzle will
-- be look like the one you imported.

-- All paths must point to your puzzle directory.

-- CAUTION! --
-- Reference keys for Images and Sprites cannot have same names! Otherwise it becomes ambiguous
-- whether you're refering to a sprite or an image. Also note that not all objects support sprites
-- (as of yet, we may add this feature later). If you're not sure if a constructor accepts an
-- image, a sprite or both, check the list below.

-- Each object has its own constructor. Below is a list of objects, their constructors and
-- arguments they admit.

--[[
// A Bucket. Stores liquid dropable content.
Bucket(content, cnt_color)
    content   - initial content of this bucket ['paint', 'water', 'empty']
    cnt_color - color of contents [see /classes/color for a list of colors]

// An Obstacle. Doesn't allow player to move to this object's tile position.
Obstacle(bg, key, d, c)
    bg  - whether to draw the background (floor) image behind this object [boolean]
    key - this object's reference key [string]
    d   - delay if it's a sprite [float]
    c   - color [string]

// A Dead. Terrible naming, I know. This is an object that kills the bot on touch (when bot reaches
// this object's tile position.
Dead(bg, key, bg, c, d)
    bg  - whether to draw the background (floor) image behind this object [boolean]
    key - a reference key either to a sprite or image [string]
    c   - color to be used to color over this object [string]
    d   - if key is a reference to a sprite, d is how fast the sprite should cycle (higher is faster) [float]

// A DeadSwitch. A Dead object that can be "switched" on (kill mode) or off (harmless mode).
// Examples of DeadSwitches are Lava and Lasers.
DeadSwitch(bg, key_on, d, c, img_off, bckt)
    bg      - whether to draw the background (floor) image behind this object [boolean]
    key_on  - reference key to either a sprite or image for when the DeadSwitch is "on" [string]
    d       - if key is a reference to a sprite, d is how fast the sprite should cycle (higher is faster) [float]
    c       - color to be used to color over this object [string]
    key_off - reference key to an image for when the DeadSwitch is "off" (if nil or omitted, it just disappears) [string]
    bckt    - whether this DeadSwitch can be turned off with a bucket's content (if omitted, false) [boolean]

// Lava. It behaves just like real-world lava, in that if you throw water or paint in it, it
// instantly becomes a solid piece of rock. Lava is a DeadSwitch triggered by water.
Lava()

// A Container is an infinite source of water or paint.
Container(bg, key, d, c, cnt, cnt_c)
    bg    - whether to draw the background (floor) image behind this object [boolean]
    key   - a reference key either to a sprite or image [string]
    d     - if key is a reference to a sprite, d is how fast the sprite should cycle (higher is faster) [float]
    c     - color to be used to color over this object [string]
    cnt   - initial content of this bucket ['paint', 'water', 'empty']
    cnt_c - color of contents [see /classes/color for a list of colors]

// A Console object is a computer that allows either input or output (but not both).
Console(img, c, bg, data, n)
    img  - key reference to an image [string]
    c    - console color [string]
    bg   - whether to draw the background (floor) image behind this object [boolean]
    data - if data is nil, then this console accepts data and is classified as 'output'. Else, the
           console is of type 'input', and the bot may take data from it. In this case, if data is
           a function with return type array, then its internal data shall be the function's return
           value. If data is an array, then this console's internal data shall be the array. [nil, func, table]
    n    - how many entries should the console show above it [int]

// An emitter emits a constant stream of deadly laser to a certain direction until obstructed by something.
// An emitter can be turned on or off by a console of the same color as its laser's color.
Emitter(img, bg, c, r_key, r_bg, r_d, r_c)
    img   - key reference to an image [string]
    bg    - whether to draw the background (floor) image behind this object [boolean]
    c     - this emitter's color [string]
    r_key - laser ray's sprite reference key [string]
    r_bg  - whether to draw the background (floor) image behind this ray [boolean]
    r_d   - this laser ray's sprite delay [float]
    r_c   - this laser ray's color [string]
--]]

-- Some objects may accept a colorifying argument. This will draw the object under a certain color
-- scale. If you don't want to color over, use 'white' instead. This will retain the object's
-- original colorscale.


Meta.SetOnStart(function()
end)

Meta.SetCompletedPopup {
    title = "The Greater Firewall",
    text  = "You have saved MarvInc from the invading hackers!",
    color = "blue",
    button1 = {
        text = "no prob",
        color = "red",
    }
}

Meta.SetObjectiveCheck(function(grid)
    local e = grid[11][11]
	local negs = Util.CheckConsoleOutput(e, ans)
	if type(negs) == 'string' then return negs end
	return negs
end)

Bot.SetPosition(1, 7)
Bot.SetOrientation "west"
